%   PCA and k-means clustering for k=24
%   Sumit Basu
%   CIS601
%   Fall 2004

%   Variables to be set:
%
%   imblk: Size of sub-images [ex. for 16x16 subimages specify 16]
%   inputpic: Input image
%   IsAllPCs:   Whether to use all Principal Components to reconstruct
%               image before clustering; values: 1 , 2
%               1:  All Principal Components
%               2:  First NoPC Principal Components only
%   NoPC: Principal Components to consider, by default all i.e image count
%               If IsAllPCs = 1, can be ignored

clear all;
imblk = 32;
inputpic =   'sample14.tif';
IsAllPCs = 2;
NoPC = 80;

%outputgpic = 'C:\601CompGraphics\MyProject\2254g.jpg';
%outputfpic = 'C:\601CompGraphics\MyProject\2254f.jpg';
im = imread(inputpic);
imshow(im)
gr = rgb2gray(im);
gr = double(gr);
figure, imshow(gr,[])
%imwrite(gr,outputgpic,'jpg');
[rw cl] = size(gr);
rwmod = rw - mod(rw,imblk);
clmod = cl - mod(cl,imblk);
rowcnt = rwmod / imblk;
clcnt = clmod / imblk;
for i = 1:rowcnt
    for j = 1:clcnt
        subim(1:imblk,1:imblk,(i - 1)*clcnt + j) = gr(((i-1)*imblk + 1):i*imblk,((j-1)*imblk + 1):j*imblk);
    end
end;

[imr imc imcnt] = size(subim);
for i = 1 : imcnt
m(i) = mean(mean(subim(1:imblk,1:imblk,i)));
m(i) = m(i) - mod(m(i),1);
o(1:imblk,1:imblk) = m(i)*ones(imblk,imblk);
subim1(1:imblk,1:imblk,i) = minus(subim(1:imblk,1:imblk,i),o(1:imblk,1:imblk));
end

[imr imc imcnt] = size(subim1);
[X, R] = imstack2vectors(subim1);

if IsAllPCs == 1
    Q = imcnt;
else
    Q = NoPC;
end

P = princomp(X, Q);
% obtain image variances
vX = var(double(X(:,:)));
subsize = imblk;

% extract principal components images pY
%for i=1:Q
%    pv = P.Y(:,i);
%    pv = reshape(pv, subsize, subsize);
%    pY(:,:,i) = pv;
%end

% extract reconstructed images pX
for i=1:imcnt
    pv = P.X(:,i);
    pv = reshape(pv, subsize, subsize);
    pX(:,:,i) = pv;
end

% extract the covariance matrix for X
pCx = P.Cx;

% extract the mean vector population for X
pmx = P.mx;

% extract the covariance matrix for Y
%pCy = P.Cy;

% extract the eigenvalues
%pev = diag(pCy);

% extract the mean squared error
pems = P.ems;

% extract the pc transformation matrix
pA = P.A;
size(pA)

% print eigenimages
%figure;
%for i=1:Q
%subplot(4,Q/4,i);
%imshow(pY(:,:,i),[]);
%end;


%for i=1:Q
%subplot(4,Q/4,i);
%imshow(pX(:,:,i),[]);
%end;

% obtain image variances
vX = var(double(X(:,:)));

for i = 1:rowcnt
    for j = 1:clcnt
        o(1:imblk,1:imblk) = m((i-1)*clcnt+ j)*ones(imblk,imblk);
        pX(:,:,(i-1)*clcnt+ j) = plus(pX(:,:,(i-1)*clcnt+ j), o(1:imblk,1:imblk));
        finalimg(((i-1)*imblk + 1):(i*imblk),((j-1)*imblk +1):(j*imblk)) = pX(:,:,(i-1)*clcnt+ j);
    end
end;

figure, imshow(finalimg,[])
%imwrite(finalimg,outputfpic,'jpg');


% Clustering to remove the background
mm = P.X';

% Use kmeans
cl = kmeans(mm,24);

cnt1 =0;
cnt2 = 0;
cnt3 = 0;
cnt4 = 0;
cnt5 = 0;
cnt6 = 0;
cnt7 = 0;
cnt8 = 0;
cnt9 = 0;
cnt10 = 0;
cnt11 = 0;
cnt12 = 0;
cnt13 = 0;
cnt14 = 0;
cnt15 = 0;
cnt16 = 0;
cnt17 = 0;
cnt18 = 0;
cnt19 = 0;
cnt20 = 0;
cnt21 = 0;
cnt22 = 0;
cnt23 = 0;
cnt24 = 0;

% Calculate cluster counts
for i = 1:imcnt
if cl(i) == 1
cnt1 = cnt1 + 1;
elseif cl(i) == 2
cnt2 = cnt2 + 1;
elseif cl(i) == 3
cnt3 = cnt3 + 1;
elseif cl(i) == 4
cnt4 = cnt4 + 1;
elseif cl(i) == 5
cnt5 = cnt5 + 1;
elseif cl(i) == 6
cnt6 = cnt6 + 1;
elseif cl(i) == 7
cnt7 = cnt7 + 1;
elseif cl(i) == 8
cnt8 = cnt8 + 1;
elseif cl(i) == 9
cnt9 = cnt9 + 1;
elseif cl(i) == 10
cnt10 = cnt10 + 1;
elseif cl(i) == 11
cnt11 = cnt11 + 1;
elseif cl(i) == 12
cnt12 = cnt12 + 1;
elseif cl(i) == 13
cnt13 = cnt13 + 1;
elseif cl(i) == 14
cnt14 = cnt14 + 1;
elseif cl(i) == 15
cnt15 = cnt15 + 1;
elseif cl(i) == 16
cnt16 = cnt16 + 1;
elseif cl(i) == 17
cnt17 = cnt17 + 1;
elseif cl(i) == 18
cnt18 = cnt18 + 1;
elseif cl(i) == 19
cnt19 = cnt19 + 1;
elseif cl(i) == 20
cnt20 = cnt20 + 1;
elseif cl(i) == 21
cnt21 = cnt21 + 1;
elseif cl(i) == 22
cnt22 = cnt22 + 1;
elseif cl(i) == 23
cnt23 = cnt23 + 1;
else
cnt24 = cnt24 + 1;
end
end;

% Find maximum cluster
maxcluster = 1;
maxcnt = cnt1;
if cnt2 > maxcnt
maxcluster = 2;
maxcnt = cnt2;
end

if cnt3 > maxcnt
maxcluster = 3;
maxcnt = cnt3;
end

if cnt4 > maxcnt
maxcluster = 4;
maxcnt = cnt4;
end

if cnt5 > maxcnt
maxcluster = 5;
maxcnt = cnt5;
end

if cnt6 > maxcnt
maxcluster = 6;
maxcnt = cnt6;
end

if cnt7 > maxcnt
maxcluster = 7;
maxcnt = cnt7;
end

if cnt8 > maxcnt
maxcluster = 8;
maxcnt = cnt8;
end

if cnt9 > maxcnt
maxcluster = 9;
maxcnt = cnt9;
end

if cnt10 > maxcnt
maxcluster = 10;
maxcnt = cnt10;
end

if cnt11 > maxcnt
maxcluster = 11;
maxcnt = cnt11;
end

if cnt12 > maxcnt
maxcluster = 12;
maxcnt = cnt12;
end

if cnt13 > maxcnt
maxcluster = 13;
maxcnt = cnt13;
end

if cnt14 > maxcnt
maxcluster = 14;
maxcnt = cnt14;
end

if cnt15 > maxcnt
maxcluster = 15;
maxcnt = cnt15;
end

if cnt16 > maxcnt
maxcluster = 16;
maxcnt = cnt16;
end

if cnt17 > maxcnt
maxcluster = 17;
maxcnt = cnt17;
end

if cnt18 > maxcnt
maxcluster = 18;
maxcnt = cnt18;
end

if cnt19 > maxcnt
maxcluster = 19;
maxcnt = cnt19;
end

if cnt20 > maxcnt
maxcluster = 20;
maxcnt = cnt20;
end

if cnt21 > maxcnt
maxcluster = 21;
maxcnt = cnt21;
end

if cnt22 > maxcnt
maxcluster = 22;
maxcnt = cnt22;
end

if cnt23 > maxcnt
maxcluster = 23;
maxcnt = cnt23;
end

if cnt24 > maxcnt
maxcluster = 24;
maxcnt = cnt24;
end

% Find average of the maximum cluster
grm = 0;
maxcnt = 0;

for i = 1:imcnt
if cl(i) == maxcluster
grm = grm + mean(mm(i,:));
maxcnt = maxcnt + 1;
end
end;

grm = grm / maxcnt;

maxforwt = max(max(mm));

% replace elements of the maximum cluster with average
endpt = subsize * subsize;
for i = 1:imcnt
if cl(i) == maxcluster
for j = 1:endpt 
mm(i,j) = maxforwt;
end
end
end;

mm1 = mm';

%reshape and show image
for i=1:imcnt
mm2 = mm1(:,i);
mm2 = reshape(mm2, subsize, subsize);
mm3(:,:,i) = mm2;
end


for i = 1:rowcnt
for j = 1:clcnt
finalimgc(((i-1)*imblk + 1):(i*imblk),((j-1)*imblk +1):(j*imblk)) = mm3(:,:,(i-1)*clcnt+ j);
end
end;
figure, imshow(finalimgc,[])